# -*- coding: utf-8 -*-
import unittest
from zope.component import getUtility
from waeup.kofa.students.interfaces import IStudentsUtils
from waeup.kofa.students.utils import formatted_text
from waeup.kofa.students.tests.test_browser import StudentsFullSetup

class FormatterTests(unittest.TestCase):

    def test_formatted_text(self):
        # we can format strings, unicode and things convertable to unicode.
        result1 = formatted_text('sample')
        result2 = formatted_text('ümlaut')
        result3 = formatted_text(3)
        result4 = formatted_text(u'unicöde')
        result5 = formatted_text(u'sample', color='red')
        self.assertTrue(isinstance(result1, unicode))
        self.assertEqual(
            result1, u'<font color="black">sample</font>')
        self.assertEqual(
            result2, u'<font color="black">ümlaut</font>')
        self.assertEqual(
            result3, u'<font color="black">3</font>')
        self.assertEqual(
            result4, u'<font color="black">unicöde</font>')
        self.assertEqual(
            result5, u'<font color="red">sample</font>')
        return

class StudentsUtilsTests(StudentsFullSetup):

    def test_setReturningData(self):
        utils = getUtility(IStudentsUtils)
        self.student['studycourse'].current_level = 600
        utils.setReturningData(self.student)
        # The new level exceeds the certificates end_level.
        # In this case current_level remains unchanged and no error is raised.
        self.assertEqual(self.student['studycourse'].current_level, 600)
